%define _libdir64 %{_prefix}/lib64
%define _fmoddir %{_libdir}/fortran/modules

Name:           netcdf-fortran
Version:        4.4.3
Release:        1
Summary:        Fortran libraries for NetCDF-4

Group:          Applications/Engineering
License:        NetCDF
URL:            http://www.unidata.ucar.edu/software/netcdf/
Source0:        http://www.unidata.ucar.edu/downloads/netcdf/ftp/%{name}-%{version}.tar.gz
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

BuildRequires:  gcc-gfortran >= 4.5.4-1
BuildRequires:  netcdf-devel >= 4.4.1-1
BuildRequires:  openssl-devel >= 1.0.1t-1
Requires:       gcc-gfortran >= 4.5.4-1
Requires:       netcdf >= 4.4.1-1
Requires:       openssl >= 1.0.1t-1

%description
Fortran libraries for NetCDF-4.


%package devel
Summary:        Development files for Fortran NetCDF API
Group:          Development/Libraries
Requires:       %{name} = %{version}-%{release}
Requires:       netcdf-devel >= 4.4.1-1
Requires:       openssl-devel >= 1.0.1t-1
Requires:       pkg-config

%description devel
This package contains the NetCDF Fortran header files, shared devel libraries,
and man pages.


%prep
%setup -q
/opt/freeware/bin/sed -i -e '1i#!/bin/sh' examples/F90/run_f90_par_examples.sh
mkdir ../32bit
mv * ../32bit
mv ../32bit .
mkdir 64bit
cd 32bit && tar cf - . | (cd ../64bit ; tar xpf -)


%build
export CONFIG_SHELL=/usr/bin/ksh
export CONFIG_ENV_ARGS=/usr/bin/ksh

export CC="xlc"
export CXX="xlC_r"

export FFLAGS="-O -I/opt/freeware/include"
export FCFLAGS="$FFLAGS"

cd 64bit
# first build the 64-bit version
export OBJECT_MODE=64
export F77="gfortran -maix64"
export FC="gfortran -maix64"
export LDFLAGS="-L/opt/freeware/lib64 -L/opt/freeware/lib -Wl,-blibpath:/opt/freeware/lib64:/opt/freeware/lib:/usr/lib:/lib -Wl,-bmaxdata:0x80000000"
./configure \
    --prefix=%{_prefix} \
    --libdir=%{_libdir64} \
    --mandir=%{_mandir} \
    --enable-shared --disable-static \
    --enable-extra-example-tests
make %{?_smp_mflags}

cd ../32bit
# now build the 32-bit version
export OBJECT_MODE=32
export F77="gfortran -maix32"
export FC="gfortran -maix32"
export LDFLAGS="-L/opt/freeware/lib -Wl,-blibpath:/opt/freeware/lib:/usr/lib:/lib -Wl,-bmaxdata:0x80000000"
./configure \
    --prefix=%{_prefix} \
    --mandir=%{_mandir} \
    --enable-shared --disable-static \
    --enable-extra-example-tests
make %{?_smp_mflags}


%install
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}

cd 64bit
export OBJECT_MODE=64
make install DESTDIR=${RPM_BUILD_ROOT}

(
  cd ${RPM_BUILD_ROOT}%{_bindir}
  for f in * ; do
    mv -f ${f} ${f}_64
  done
)

cd ../32bit
export OBJECT_MODE=32
gmake DESTDIR=${RPM_BUILD_ROOT} install

(
  cd ${RPM_BUILD_ROOT}%{_libdir64}
  for f in *.a ; do
    /usr/bin/ar -X64 -x ${f}
  done

  cd ${RPM_BUILD_ROOT}%{_libdir}
  for f in *.a ; do
    /usr/bin/ar -X32 -x ${f}
  done
)

# Fortran modules
mkdir -p ${RPM_BUILD_ROOT}%{_fmoddir}
mv ${RPM_BUILD_ROOT}%{_includedir}/*.mod ${RPM_BUILD_ROOT}%{_fmoddir}

# add the 64-bit shared objects to the shared libraries containing already the
# 32-bit shared objects
for f in cdff ; do
  /usr/bin/ar -X64 -q ${RPM_BUILD_ROOT}%{_libdir}/libnet${f}.a ${RPM_BUILD_ROOT}%{_libdir64}/libnet${f}.so*
done

(
  cd ${RPM_BUILD_ROOT}
  for dir in bin include lib lib64
  do
    mkdir -p usr/${dir}
    cd usr/${dir}
    ln -sf ../..%{_prefix}/${dir}/* .
    cd -
  done
)


%clean
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}


%files
%doc 32bit/COPYRIGHT 32bit/README
%{_libdir}/*.a
%{_libdir}/*.so*
%{_libdir64}/*.so*
/usr/lib/*.a
/usr/lib/*.so*
/usr/lib64/*.so*


%files devel
%doc 32bit/examples
%{_bindir}/nf-config*
%{_includedir}/*
%{_libdir}/*.la
%{_libdir64}/*.la
%{_fmoddir}/*.mod
%{_libdir}/pkgconfig/netcdf-fortran.pc
%{_libdir64}/pkgconfig/netcdf-fortran.pc
%{_mandir}/man3/*
/usr/bin/nf-config*
/usr/include/*
/usr/lib/*.la
/usr/lib64/*.la


%changelog
* Tue Sep 20 2016 Michael Perzl <michael@perzl.org> - 4.4.3-1
- updated to version 4.4.3

* Fri Mar 04 2016 Michael Perzl <michael@perzl.org> - 4.4.2-2
- recompiled against latest version of openssl

* Tue Jan 05 2016 Michael Perzl <michael@perzl.org> - 4.4.2-1
- updated to version 4.4.2

* Tue Jan 05 2016 Michael Perzl <michael@perzl.org> - 4.4.1-1
- updated to version 4.4.1

* Tue Jan 05 2016 Michael Perzl <michael@perzl.org> - 4.4.0-1
- updated to version 4.4.0

* Thu Jun 14 2012 Michael Perzl <michael@perzl.org> - 4.2-1
- first version for AIX V5.1 and higher
